HW4Q3<-read.table("HW4Q3.txt")

library(mgcv)
library(caret)
library(dplyr)


### Fit a smooth function on the continuous variables

GAM.Model<-gam(health.index~social.type+diet+born+s(enclosure.size)+
                   s(body.weight)+s(enclosure.shared),
               data=HW4Q3)

### Random forest is fairly straightforward. On my computer, 500 trees
### does not take long, because it is a small data set. If it is
### slower on your computer, you can try reducing ntree, though I
### doubt that will be necessary.

RF.Model<-train(HW4Q3[,-7],
                HW4Q3[,7],
                method="rf",
                trControl=trainControl(method="repeatedcv",number=10,repeats=2),
                tuneGrid=expand.grid(mtry=seq_len(5)),ntree=500)

### Log transform long-tailed predictors, and include interaction
### between enclosure size and body weight.

GLM.Formula<-health.index~social.type+diet+born+log(enclosure.size)+
                   log(body.weight)+enclosure.shared+enclosure.size/sqrt(body.weight)+enclosure.size/(sqrt(enclosure.shared)*sqrt(body.weight))

              

GLM.Model<-lm(GLM.Formula,data=HW4Q3)
